"use strict";
var __extends = (this && this.__extends) || function (d, b) {
    for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
    function __() { this.constructor = d; }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
};
var React = require('react');
function titlize(prop) {
    return prop[0].toUpperCase() + prop.substr(1);
}
function buildStated(prop, overrides) {
    return {
        name: prop,
        get: (overrides && overrides.get) || "get" + titlize(prop),
        set: (overrides && overrides.set) || "set" + titlize(prop),
        clear: (overrides && overrides.clear) || "clear" + titlize(prop),
        default: (overrides && overrides.default) || "default" + titlize(prop),
        change: (overrides && overrides.change) || "on" + titlize(prop) + "Change",
        callback: (overrides && overrides.callback) || "on" + titlize(prop) + "Change",
        getValue: (overrides && overrides.getValue) || (function (event) { return event.target.value; })
    };
}
function normalize(props) {
    if (!props) {
        return [{
                name: 'value',
                get: 'getValue',
                set: 'setValue',
                clear: 'clearValue',
                default: 'defaultValue',
                change: 'onChange',
                callback: 'onChange',
                getValue: function (event) { return event.target.value; }
            }];
    }
    if (typeof props === 'string') {
        return [buildStated(props)];
    }
    if (Array.isArray(props)) {
        return props.map(function (prop) {
            if (typeof prop === 'string') {
                return buildStated(prop);
            }
            if (prop && typeof prop === 'object') {
                return buildStated(prop.name, prop);
            }
        }).filter(function (prop) { return prop; });
    }
    if (typeof props === 'object') {
        return [buildStated(props.name, props)];
    }
    return [];
}
function stated(props) {
    var statedProps = normalize(props);
    return function wrapper(Component) {
        var Stated = (function (_super) {
            __extends(Stated, _super);
            function Stated(props) {
                var _this = this;
                _super.call(this, props);
                this.callbacks = {};
                this.state = {};
                statedProps.forEach(function (stated) {
                    _this.state[stated.name] = props[stated.default];
                    _this.callbacks[stated.callback] = function () {
                        var args = [];
                        for (var _i = 0; _i < arguments.length; _i++) {
                            args[_i - 0] = arguments[_i];
                        }
                        _this.setState((_a = {}, _a[stated.name] = stated.getValue.apply(stated, args), _a));
                        if (typeof _this.props[stated.change] === 'function') {
                            (_b = _this.props)[stated.change].apply(_b, args);
                        }
                        var _a, _b;
                    };
                    _this[stated.get] = function () { return _this.state[stated.name]; };
                    _this[stated.set] = function (value) { return _this.setState((_a = {}, _a[stated.name] = value, _a)); var _a; };
                    _this[stated.clear] = function () { return _this.setState((_a = {}, _a[stated.name] = _this.props[stated.default], _a)); var _a; };
                });
            }
            Stated.prototype.render = function () {
                return React.createElement(Component, React.__spread({}, this.props, this.state, this.callbacks));
            };
            return Stated;
        }(React.Component));
        return Stated;
    };
}
exports.__esModule = true;
exports["default"] = stated;
